package it.holhoconverter.converter;

import it.holhoconverter.language.LangManager;

public enum ConversionMode
{
    PIRAMID("conversion.mode.piramid", 4, new String[] { "-filter_complex", "[0:0]crop=ih:ih:iw/2-ih/2:0[a];[a]scale=(RES):(RES)[b];[b]pad=(RES)*3:(RES)*3:(RES):0[c];[1:0]crop=ih:ih:iw/2-ih/2:0[d];[d]scale=(RES):(RES)[e];[e]transpose=2[f];[2:0]crop=ih:ih:iw/2-ih/2:0[g];[g]scale=(RES):(RES)[h];[h]transpose=1[i];[3:0]crop=ih:ih:iw/2-ih/2:0[j];[j]scale=(RES):(RES)[k];[k]rotate=180*PI/180[l];[c][f]overlay=0:(RES)[x];[x][i]overlay=(RES)*2:(RES)[y];[y][l]overlay=(RES):(RES)*2" }),
    PIRAMID_REVERSED("conversion.mode.piramid.reversed", 4, new String[] { "-filter_complex", "[0:0]crop=ih:ih:iw/2-ih/2:0[u];[u]scale=(RES):(RES)[p];[p]rotate=180*PI/180[b];[b]pad=(RES)*3:(RES)*3:(RES):0[c];[1:0]crop=ih:ih:iw/2-ih/2:0[d];[d]scale=(RES):(RES)[e];[e]transpose=1[f];[2:0]crop=ih:ih:iw/2-ih/2:0[g];[g]scale=(RES):(RES)[h];[h]transpose=2[i];[3:0]crop=ih:ih:iw/2-ih/2:0[j];[j]scale=(RES):(RES)[l];[c][f]overlay=0:(RES)[x];[x][i]overlay=(RES)*2:(RES)[y];[y][l]overlay=(RES):(RES)*2" }),
    NORMAL("conversion.mode.normal", 1, null);
    
    String commands[];
    int inputs;
    public String nameKey;
    
    ConversionMode(String nameKey, int inputs, String[] commands)
    {
    	this.nameKey = nameKey;
    	this.commands = commands;
        this.inputs = inputs;
    }
    
    public String[] getFFMpegCommands(FFMpegQuality quality)
    {
   	    if(this == PIRAMID || this == PIRAMID_REVERSED)
   	    {
   	    	return new String[] { commands[0], commands[1].replace("(RES)", String.valueOf(quality.res)) };
   	    }
   	    
   	    return commands;
    }
    
    public static String[] getNames()
    {
    	String[] names = new String[values().length];
    	for(int i = 0; i < values().length; i++)
    	{
    		names[i] = LangManager.getTranslated(values()[i].nameKey);
    	}
    	return names;
    }
    
    public static ConversionMode getMode(String key)
    {
    	for(int i = 0; i < values().length; i++)
    	{
    		if(values()[i].nameKey.equals(LangManager.getKey(key)))
    			return values()[i];
    	}
    	
    	return null;
    }
}