package it.holhoconverter.converter;

import it.holhoconverter.utils.DirUtils;
import it.holhoconverter.utils.Utils;
import it.holhoconverter.utils.DirUtils.OS;

import java.util.ArrayList;

public class ConversionPack
{
	private VideoInput input;
	private VideoOutput output;
	public ConversionMode conv_mode;
	public double percent = 0.0D;
	public boolean converted = false;
	public boolean toRemove = false;
	public boolean converting = false;


	public ConversionPack(String input_path, String output_path,
			FFMpegFormats format, FFMpegQuality quality, ConversionMode conv_mode)
	{
		input = new VideoInput(input_path);
		output = new VideoOutput(output_path, format, quality);
		this.conv_mode = conv_mode;
	}

	public VideoInput getInput()
	{
		return input;
	}

	public VideoOutput getOutput()
	{
		return output;
	}
	
	public ConversionMode getConversionMode()
	{
		return conv_mode;
	}
	
	public String[] getFFMpegCommands()
	{
		ArrayList<String> complete_command = new ArrayList<String>();

		int inputs = conv_mode.inputs;

		for (int i = 0; i < inputs; i++)
		{
			complete_command.addAll(Utils.arrayToList(input.getFFMpegCommands()));
		}

		if (conv_mode.getFFMpegCommands(output.quality) != null)
			complete_command.addAll(Utils.arrayToList(conv_mode.getFFMpegCommands(output.quality)));

		if(DirUtils.getPlatform() == OS.macos)
		{
			complete_command.add("-strict");
		    complete_command.add("-2");
		}
		
		complete_command.addAll(Utils.arrayToList(output.getFFMpegCommands()));

		return Utils.listToArray(complete_command);
	}

}
