package it.holhoconverter.converter;

import it.holhoconverter.language.LangManager;

public enum FFMpegQuality
{
    LOW("ffmpeg.quality.min", 5, 240),
    HIGH("ffmpeg.quality.hig", 0, 360);
    
    public int value;
    public int res;
    public String name;
    
    FFMpegQuality(String name, int value, int res)
    {
    	this.value = value;
    	this.name = name;
    	this.res = res;
    }
    
    public static String[] getNames()
    {
    	String[] names = new String[values().length];
    	for(int i = 0; i < values().length; i++)
    	{
    		names[i] = LangManager.getTranslated(values()[i].name);
    	}
    	return names;
    }
    
    public static FFMpegQuality getQuality(String key)
    {
    	for(int i = 0; i < values().length; i++)
    	{
    		if(values()[i].name.equals(LangManager.getKey(key)))
    			return values()[i];
    	}
    	
    	return null;
    }
}
