package it.holhoconverter.converter;

import it.holhoconverter.HolhoConverter;
import it.holhoconverter.utils.DirUtils;
import it.holhoconverter.utils.Utils;
import it.holhoconverter.utils.DirUtils.OS;

import java.io.File;
import java.util.ArrayList;

public class VideoOutput
{
	public File file;
	public boolean override = true;
	public FFMpegQuality quality;
	private FFMpegFormats format;
	public boolean activeAudio = true;
	public int bitrate = -1;

	public VideoOutput(File file, FFMpegFormats format, FFMpegQuality quality)
	{
		this.file = file;
		this.quality = quality;
		this.format = format;
	}

	public VideoOutput(String path, FFMpegFormats format, FFMpegQuality quality)
	{
		this.file = new File(path);
		this.quality = quality;
		this.format = format;
	}

	public String[] getFFMpegCommands()
	{
		ArrayList<String> commands = new ArrayList<String>();
		
		commands.add("-q:v");
		commands.add(String.valueOf(quality.value));
		
		if(!activeAudio)
			commands.add("-an");
		
		if(bitrate != -1)
		{
			commands.add("-b");
		    commands.add(String.valueOf(bitrate));
		}
		
		if(override)
			commands.add("-y");
		
		commands.add(DirUtils.getPlatform() == OS.macos ? file.getAbsolutePath() : ("\"" + file.getAbsolutePath() + "\""));
		
		return Utils.listToArray(commands);
	}

	public FFMpegFormats getFormat()
	{
		return format;
	}
	
	public void setFormat(FFMpegFormats format)
	{
	    this.format = format;
	    
	    this.file = new File(file.getParentFile().getAbsolutePath() + File.separator + Utils.replaceFileExtension(file.getName(), format.extension));
	
	    for(int i = 0; i < VideoConverter.conversionpacks.size(); i++)
	    {
	    	if(VideoConverter.conversionpacks.get(i).getOutput() == this)
	    	{
	    		HolhoConverter.instance.mainFrame.conversionTable.setValueAt(file.getAbsolutePath(), i, 1);
	    		break;
	    	}
	    }
	}
	
	public void setOverride(boolean b)
	{
		override = b;
	}
}
