package it.holhoconverter.frames;

import it.holhoconverter.HolhoConverter;
import it.holhoconverter.Resources;

import java.awt.Dimension;
import java.awt.Toolkit;

import javax.swing.JFrame;

public abstract class HolhoFrame extends JFrame implements ILangComponent
{
	private static final long serialVersionUID = 1L;

	public HolhoFrame()
	{
		HolhoConverter.instance.registerLangComponent(this);
		this.setIconImage(Resources.getIcon(HolhoConverter.ICONS_PKG + "icon.png").getImage());
	}
	
	public void setCentered()
	{
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		
		double width = screenSize.getWidth();
		double height = screenSize.getHeight();
		
		this.setLocation((int)width/2 - this.getWidth()/2, (int)height/2 - this.getHeight()/2);
	}
}
