package it.holhoconverter.frames;

import it.holhoconverter.HolhoConverter;
import it.holhoconverter.language.LangManager;

import javax.swing.JProgressBar;
import javax.swing.JTable;

public class ProgressBarCell extends JProgressBar implements ILangComponent
{
	private static final long serialVersionUID = 1L;

	public JTable table;
	public int row;
	public int column;
	
	public String status = "blank";
	
	public ProgressBarCell(JTable table, int row, int column)
	{
		super(0, 100);
		setValue(0);
		setStringPainted(true);
		this.table = table;
		this.row = row;
		this.column = column;
		HolhoConverter.instance.registerLangComponent(this);
	}

	public void onTableValueChanged()
	{
		Object obj = table.getValueAt(row, column);
		if (obj != null)
		{
			if (Integer.valueOf(String.valueOf(obj)) >= 0 && Integer.valueOf(String.valueOf(obj)) <= 100)
			{
				this.setValue(Integer.valueOf(String.valueOf(obj)));
				this.setString((Integer.valueOf(String.valueOf(obj)) > 100 ? 100 : Integer.valueOf(String.valueOf(obj))) + "%");
				this.status = "blank";
			}
			else if (Integer.valueOf(String.valueOf(obj)) == 101)
			{
				this.setValue(100);
				this.status = "progressbar.complete";
				this.setString(LangManager.getTranslated(status));
			}
			else if (Integer.valueOf(String.valueOf(obj)) == -2)
			{
				this.status = "progressbar.converting";
				this.setString(LangManager.getTranslated(status));
			}
			else
			{
				this.status = "progressbar.error";
				this.setString(LangManager.getTranslated(status));
			}
		}
	}

	@Override
	public void updateLanguage()
	{
		if(!status.equals("blank"))
			this.setString(LangManager.getTranslated(status));
	}
}
