package it.holhoconverter.frames;

import it.holhoconverter.HolhoConverter;
import it.holhoconverter.language.LangManager;

import java.awt.Graphics;

import javax.swing.JProgressBar;

public class ProgressBarHide extends JProgressBar implements ILangComponent
{
	private static final long serialVersionUID = 1L;

	public boolean draw_flag = true;
	public boolean extractNatives = false;
	
	public ProgressBarHide()
	{
		this.setStringPainted(true);
		HolhoConverter.instance.registerLangComponent(this);
	}
	
	@Override
	public void paint(Graphics g)
	{
	    if(draw_flag)
	    	super.paint(g);
	}
	
	@Override
	public void setValue(int value)
	{
		super.setValue(value);
		this.setString(value + "%");
	}

	@Override
	public void updateLanguage()
	{
		if(extractNatives)
		{
			this.setString(LangManager.getTranslated("natives.extracting") + " " + this.getValue() + "%");
		}
	}
}
