package it.holhoconverter.language;

import it.holhoconverter.utils.Logger;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Set;

public class LangPack
{
	public HashMap<String, String> langMap = new HashMap<String, String>();
	
	public String langName;

	public LangPack(String langName, InputStream input)
	{
		this.langName = langName;
		
		try
		{
			if (input != null)
			{
				BufferedReader br = new BufferedReader(new InputStreamReader(input));

				String line;

				while ((line = br.readLine()) != null)
				{
					if (line.contains("="))
					{
						String key = line.split("=")[0];
						String value = line.substring(key.length() + 1);

						langMap.put(key, value);
					}
				}
				br.close();
			}
			else
			{
				Logger.log(Logger.GRAVE, "Error on loading language pack ! InputStream param was null!");
			}
		}
		catch (IOException e)
		{
			Logger.log(Logger.GRAVE, "Error on loading language pack!");
			e.printStackTrace();
		}
	}
	
	public String getTranslated(String key)
	{
		if(langMap.containsKey(key))
		{
			return langMap.get(key);
		}
		
		return key;
	}
	
	public String getKey(String translated)
	{
		if(langMap.containsValue(translated))
		{
			Set<String> keys = langMap.keySet();
			
			for(String key : keys)
			{
				if(langMap.get(key).equals(translated))
					return key;
			}
		}
		
		return translated;
	}
}
