package it.holhoconverter.utils;

import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;


public class LogPrintStream extends PrintStream
{
	private final OutputStream[] streams;

	public LogPrintStream(OutputStream... streams)
	{
		super(streams[0]);
		this.streams = streams;
	}

	@Override
	public void close()
	{
		super.close();
		for (int i = 1; i < streams.length; i++)
		{
			((PrintStream)streams[i]).close();
		}
	}

	@Override
	public void flush()
	{
		super.flush();
		for (int i = 1; i < streams.length; i++)
		{
			((PrintStream)streams[i]).flush();
		}
	}

	@Override
	public void write(byte[] buf, int off, int len)
	{
		super.write(buf, off, len);
		for (int i = 1; i < streams.length; i++)
		{
			((PrintStream)streams[i]).write(buf, off, len);
		}
	}

	@Override
	public void write(int b)
	{
		super.write(b);
		for (int i = 1; i < streams.length; i++)
		{
			((PrintStream)streams[i]).write(b);
		}
	}

	@Override
	public void write(byte[] b) throws IOException
	{
		super.write(b);
		for (int i = 1; i < streams.length; i++)
		{
			((PrintStream)streams[i]).write(b);
		}
	}
}
